package org.apidesign.apifest08.test;

import static org.apidesign.apifest08.test.Task1Test.CZK;
import static org.apidesign.apifest08.test.Task1Test.USD;
import static org.junit.Assert.assertEquals;

import java.math.BigDecimal;

import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.ConvertorFactory;
import org.apidesign.apifest08.currency.Money;
import org.apidesign.apifest08.currency.MoneyImpl;
import org.junit.Test;


public class ConvertorTest {

	private static final Convertor CZK_TO_USD_CONVERTOR = ConvertorFactory.createConvertor(new MoneyImpl(17,CZK), new MoneyImpl(1,USD));
	@Test
	public void testConvertSmall()
	{
		Money converted = CZK_TO_USD_CONVERTOR.convert(new MoneyImpl(0.17,CZK),USD);
		assertEquals(new MoneyImpl(new BigDecimal("0.01"),USD),converted);
		assertEquals(USD,converted.getCurrency());
	}
	@Test
	public void testConvertSmallReverse()
	{
		Money converted = CZK_TO_USD_CONVERTOR.convert(new MoneyImpl(0.01,USD),CZK);
		assertEquals(new MoneyImpl(new BigDecimal("0.17"),CZK),converted);
	}
}
